#ifndef dud4_playertask_hh
#define dud4_playertask_hh

#include <string>

#include "task.hh"
#include "events.hh"
#include "buffer.hh"

class playertask : public task
{
	int sock;
	std::string input;                 // Current input line
	
	mutable unsigned char got_iac;     // Telnet option
	mutable unsigned char got_sb;      // Sub option;
	mutable unsigned char got_si;      // Data index;
	mutable unsigned char got_data[4]; // Buffer
	enum { f_visible, f_hidden, f_normal } flowmode;
	std::string inputcharset;          // Not for f_normal
	std::string inputprompt;                
	unsigned inputmaxlen;
	mutable bool inputhidden;
	
	class playerdata *data;
	
	friend class playerdata;
	
	void shut();
	void inputok() const;
    void telnetsend(int code, ...) const;
    
    void setprompt(const std::string &prompt, unsigned maxlength, bool visible, const std::string &charset);
    void setlflow();
    
    void private_echo(const std::string &s) const;
    void hideprompt() const;
    void showprompt() const;
    
    mutable Buffer SendQueue;
	
public:
	playertask(int s);
	~playertask();
	
	virtual void echo(const std::string &s, bool addcr = true) const;
	virtual bool tick();
	virtual void operator += (const event &ev);

	virtual unsigned numpolls() const;
	virtual void writepolls(struct pollfd *arr);
	virtual void checkpolls(const struct pollfd *arr);
};

#endif
